# -*- coding: utf-8 -*-
import os
import sys
package_path = '/user/specified/path/to/matsdp/'
sys.path.insert(0, os.path.abspath(package_path))

def test_plot_dos():
    from matsdp.vasp import vasp_plot

    dos1_file_path = './vasp/DOSCAR'
    retn_val1 = vasp_plot.plot_dos(
        atom_doscar_file_path_list = [dos1_file_path],
        atom_sysname_list = ['C5'],
        atom_indx_list = ['Ni1'],
        atom_palette_list = ['black'],
        atom_subplot_arg_list = [111],
        subplot_arg_list = [111],
        subplot_xlo_list = [-6.5],
        subplot_xhi_list = [4.0],
        subplot_ylo_list = [None],
        subplot_yhi_list = [None],
        subplot_xtick_list = [True],
        subplot_ytick_list = [True],
        subplot_xlabel_list = [False],
        subplot_ylabel_list = [False],
        subplot_share_xy_list = [False, False],
        mainplot_axis_label_list = [True, True],
        xtick_direction = 'out',
        ytick_direction = 'out',
        dos_mode_dict = None,
        fermi_shift_zero = True,
        peak_analyzer = False,
        peak_analyzer_factor = 0.02,
        smoothing = False,
        smoothing_factor = 0.05,
        line_width = 2.0,
        font_size = 18,
        fig_format = 'png',
        fig_size = [13.0, 9.5],
        fig_dpi = 600,
        )
    retn_val2 = vasp_plot.plot_dos(
        atom_doscar_file_path_list = [dos1_file_path, dos1_file_path],
        atom_sysname_list = ['C1', 'C1'],
        atom_indx_list = ['Ni1', 'Re1'],
        atom_palette_list = ['black', 'red'],
        atom_subplot_arg_list = [111, 111],
        subplot_arg_list = [111],
        subplot_xlo_list = [-6.5],
        subplot_xhi_list = [4.0],
        subplot_ylo_list = [None],
        subplot_yhi_list = [None],
        subplot_xtick_list = [True],
        subplot_ytick_list = [True],
        subplot_xlabel_list = [False],
        subplot_ylabel_list = [False],
        subplot_share_xy_list = [False, False],
        mainplot_axis_label_list = [True, True],
        xtick_direction = 'out',
        ytick_direction = 'out',
        dos_mode_dict = {'Ni':['d'], 'Re':['d']},
        fermi_shift_zero = True,
        peak_analyzer = False,
        peak_analyzer_factor = 0.02,
        smoothing = False,
        smoothing_factor = 0.05,
        line_width = 2.0,
        font_size = 18,
        fig_format = 'png',
        fig_size = [11.0, 9.5],
        fig_dpi = 600,
        )
    retn_val3 = vasp_plot.plot_dos(
        atom_doscar_file_path_list = [dos1_file_path, dos1_file_path],
        atom_sysname_list = ['C1', 'C1'],
        atom_indx_list = ['Ni1', 'Re1'],
        atom_palette_list = ['black', 'red'],
        atom_subplot_arg_list = [111, 111],
        subplot_arg_list = [111],
        subplot_xlo_list = [-6.5],
        subplot_xhi_list = [4.0],
        subplot_ylo_list = [None],
        subplot_yhi_list = [None],
        subplot_xtick_list = [True],
        subplot_ytick_list = [True],
        subplot_xlabel_list = [False],
        subplot_ylabel_list = [False],
        subplot_share_xy_list = [False, False],
        mainplot_axis_label_list = [True, True],
        xtick_direction = 'in',
        ytick_direction = 'in',
        dos_mode_dict = {'Ni':['d'], 'Re':['d']},
        fermi_shift_zero = True,
        peak_analyzer = False,
        peak_analyzer_factor = 0.02,
        smoothing = True,
        smoothing_factor = 0.05,
        line_width = 2.0,
        font_size = 18,
        fig_format = 'png',
        fig_size = [11.0, 9.5],
        fig_dpi = 600,
        )
    retn_val4 = vasp_plot.plot_dos(
        atom_doscar_file_path_list = [dos1_file_path, dos1_file_path],
        atom_sysname_list = ['C1', 'C1'],
        atom_indx_list = ['Ni2', 'Re1'],
        atom_palette_list = ['black', 'red'],
        atom_subplot_arg_list = [211, 212],
        subplot_arg_list = [211, 212],
        subplot_xlo_list = [-6.5, -6.5],
        subplot_xhi_list = [4.0, 4.0],
        subplot_ylo_list = [None, None],
        subplot_yhi_list = [None, None],
        subplot_xtick_list = [True, True],
        subplot_ytick_list = [True, True],
        subplot_xlabel_list = [False, False],
        subplot_ylabel_list = [False, False],
        subplot_share_xy_list = [False, False],
        mainplot_axis_label_list = [True, True],
        xtick_direction = 'out',
        ytick_direction = 'out',
        dos_mode_dict = {'Ni':['d'], 'Re':['d']},
        fermi_shift_zero = True,
        peak_analyzer = False,
        peak_analyzer_factor = 0.02,
        smoothing = False,
        smoothing_factor = 0.05,
        line_width = 2.0,
        font_size = 18,
        fig_format = 'png',
        fig_size = [11.0, 9.5],
        fig_dpi = 600,
        )

    retn_val5 = vasp_plot.plot_dos(
        atom_doscar_file_path_list = [dos1_file_path, dos1_file_path],
        atom_sysname_list = ['C1', 'C1'],
        atom_indx_list = ['Ni2', 'Re1'],
        atom_palette_list = ['black', 'red'],
        atom_subplot_arg_list = [211, 212],
        subplot_arg_list = [211, 212],
        subplot_xlo_list = [-6.5, -6.5],
        subplot_xhi_list = [4.0, 4.0],
        subplot_ylo_list = [None, None],
        subplot_yhi_list = [None, None],
        subplot_xtick_list = [False, True],
        subplot_ytick_list = [True, True],
        subplot_xlabel_list = [False, False],
        subplot_ylabel_list = [False, False],
        subplot_share_xy_list = [True, False],
        mainplot_axis_label_list = [True, True],
        xtick_direction = 'out',
        ytick_direction = 'out',
        dos_mode_dict = {'Ni':['d'], 'Re':['d']},
        fermi_shift_zero = True,
        peak_analyzer = False,
        peak_analyzer_factor = 0.02,
        smoothing = False,
        smoothing_factor = 0.05,
        line_width = 2.0,
        font_size = 18,
        fig_format = 'png',
        fig_size = [11.0, 9.5],
        fig_dpi = 600,
        )


    retn_val6 = vasp_plot.plot_dos(
        atom_doscar_file_path_list = [dos1_file_path, dos1_file_path, dos1_file_path, dos1_file_path],
        atom_sysname_list = ['C1', 'C1', 'C1', 'C1'],
        atom_indx_list = ['Ni2', 'Re1', 'Ni1', 'Ni5'],
        atom_palette_list = ['black', 'red', 'blue', 'green'],
        atom_subplot_arg_list = [221, 222, 223, 224],
        subplot_arg_list = [221, 222, 223, 224],
        subplot_xlo_list = [-4.5, -6.5, -4.5, -6.5],
        subplot_xhi_list = [4.0, 4.0, 4.0, 4.0],
        subplot_ylo_list = [None, None, None, None],
        subplot_yhi_list = [None, None, None, None],
        subplot_xtick_list = [True, True, True, True],
        subplot_ytick_list = [True, True, True, True],
        subplot_xlabel_list = [False, False, False, False],
        subplot_ylabel_list = [False, False, False, False],
        subplot_share_xy_list = [False, False],
        mainplot_axis_label_list = [True, True],
        xtick_direction = 'out',
        ytick_direction = 'out',
        dos_mode_dict = {'Ni':['d'], 'Re':['d']},
        fermi_shift_zero = True,
        peak_analyzer = False,
        peak_analyzer_factor = 0.02,
        smoothing = False,
        smoothing_factor = 0.05,
        line_width = 2.0,
        font_size = 18,
        fig_format = 'png',
        fig_size = [11.0, 9.5],
        fig_dpi = 600,
        )
    retn_val7 = vasp_plot.plot_dos(
        atom_doscar_file_path_list = [dos1_file_path, dos1_file_path, dos1_file_path, dos1_file_path],
        atom_sysname_list = ['C1', 'C1', 'C1', 'C1'],
        atom_indx_list = ['Ni2', 'Re1', 'Ni1', 'Ni5'],
        atom_palette_list = ['black', 'red', 'blue', 'green'],
        atom_subplot_arg_list = [221, 222, 223, 224],
        subplot_arg_list = [221, 222, 223, 224],
        subplot_xlo_list = [-4.5, -6.5, -4.5, -6.5],
        subplot_xhi_list = [4.0, 4.0, 4.0, 4.0],
        subplot_ylo_list = [-2.3, -2.3, -2.3, -2.3],
        subplot_yhi_list = [2.5, 2.5, 2.5, 2.5],
        subplot_xtick_list = [False, False, True, True],
        subplot_ytick_list = [True, False, True, False],
        subplot_xlabel_list = [False, False, False, False],
        subplot_ylabel_list = [False, False, False, False],
        subplot_share_xy_list = [True, True],
        mainplot_axis_label_list = [True, True],
        xtick_direction = 'out',
        ytick_direction = 'out',
        dos_mode_dict = {'Ni':['d'], 'Re':['d']},
        fermi_shift_zero = True,
        peak_analyzer = False,
        peak_analyzer_factor = 0.02,
        smoothing = False,
        smoothing_factor = 0.05,
        line_width = 2.0,
        font_size = 18,
        fig_format = 'png',
        fig_size = [11.0, 9.5],
        fig_dpi = 600,
        )
    assert isinstance(retn_val1[1],dict) == True and isinstance(retn_val2[1],dict) == True and isinstance(retn_val3[1],dict) == True and isinstance(retn_val4[1],dict) == True and isinstance(retn_val5[1],dict) == True and isinstance(retn_val6[1],dict) == True and isinstance(retn_val7[1],dict) == True

