def vasp_help():
    vasp_help_dict = {}
    vasp_help_dict['SYSTEM']        = ''
    vasp_help_dict['NWRITE']        = 'write-flag & timer'
    vasp_help_dict['PREC']          = 'normal or accurate (medium, high low for compatibility)'
    vasp_help_dict['ISTART']        = 'job   : 0-new  1-cont  2-samecut'
    vasp_help_dict['ICHARG']        = 'charge: 1-file 2-atom 10-const'
    vasp_help_dict['ISPIN']         = 'spin polarized calculation?'
    vasp_help_dict['LNONCOLLINEAR'] = 'non collinear calculations'
    vasp_help_dict['LSORBIT']       = 'spin-orbit coupling'
    vasp_help_dict['INIWAV']        = 'electr: 0-lowe 1-rand  2-diag'
    vasp_help_dict['LASPH']         = 'aspherical Exc in radial PAW'
    vasp_help_dict['METAGGA']       = 'non-selfconsistent MetaGGA calc.'
    vasp_help_dict['ENCUT']         = ''
    vasp_help_dict['ENINI']         = 'initial cutoff'
    vasp_help_dict['ENAUG']         = 'augmentation charge cutoff'
    vasp_help_dict['NELM']          = 'number of ELM steps'
    vasp_help_dict['NELMIN']        = ''
    vasp_help_dict['NELMDL']        = ''
    vasp_help_dict['EDIFF']         = 'stopping-criterion for ELM'
    vasp_help_dict['LREAL']         = 'real-space projection'
    vasp_help_dict['NLSPLINE']      = 'spline interpolate recip. space projectors'
    vasp_help_dict['LCOMPAT']       = 'compatible to vasp.4.4'
    vasp_help_dict['GGA_COMPAT']    = 'GGA compatible to vasp.4.4-vasp.4.6'
    vasp_help_dict['LMAXPAW']       = 'max onsite density'
    vasp_help_dict['LMAXMIX']       = 'max onsite mixed and CHGCAR'
    vasp_help_dict['VOSKOWN']       = 'Vosko Wilk Nusair interpolation'
    vasp_help_dict['ROPT']          = ''
    vasp_help_dict['EDIFFG']        = 'stopping-criterion for IOM'
    vasp_help_dict['NSW']           = 'number of steps for IOM'
    vasp_help_dict['NBLOCK']        = ''
    vasp_help_dict['KBLOCK']        = ''
    vasp_help_dict['IBRION']        = 'ionic relax: 0-MD 1-quasi-New 2-CG'
    vasp_help_dict['NFREE']         = 'steps in history (QN), initial steepest desc. (CG)'
    vasp_help_dict['ISIF']          = 'stress and relaxation'
    vasp_help_dict['IWAVPR']        = 'prediction:  0-non 1-charg 2-wave 3-comb'
    vasp_help_dict['ISYM']          = '0-nonsym 1-usesym 2-fastsym'
    vasp_help_dict['LCORR']         = '  Harris-Foulkes like correction to forces'
    vasp_help_dict['POTIM']         = 'time-step for ionic-motion'
    vasp_help_dict['TEIN']          = 'initial temperature'
    vasp_help_dict['TEBEG']         = 'TEEND  =   0.0 temperature during run'
    vasp_help_dict['SMASS']         = 'Nose mass-parameter (am)'
    vasp_help_dict['SCALEE']        = 'scale energy and forces'
    vasp_help_dict['NPACO']         = ''
    vasp_help_dict['APACO']         = 'distance and number of slots for P.C.'
    vasp_help_dict['PSTRESS']       = 'pullay stress'
    vasp_help_dict['POMASS']        = ''
    vasp_help_dict['ZVAL']          = ''
    vasp_help_dict['RWIGS']         = ''
    vasp_help_dict['VCA']           = ''
    vasp_help_dict['NELECT']        = 'total number of electrons'
    vasp_help_dict['NUPDOWN']       = 'fix difference up-down'
    vasp_help_dict['EMIN']          = 'minimum energy-range for DOS'
    vasp_help_dict['EMAX']          = 'maximum energy-range for DOS'
    vasp_help_dict['EFERMI']        = ''
    vasp_help_dict['ISMEAR']        = ''
    vasp_help_dict['SIGMA']         = 'broadening in eV -4-tet -1-fermi 0-gaus'
    vasp_help_dict['IALGO']         = 'algorithm'
    vasp_help_dict['LDIAG']         = 'sub-space diagonalisation (order eigenvalues)'
    vasp_help_dict['LSUBROT']       = 'optimize rotation matrix (better conditioning)'
    vasp_help_dict['TURBO']         = '0=normal 1=particle mesh'
    vasp_help_dict['IRESTART']      = '0=no restart 2=restart with 2 vectors'
    vasp_help_dict['NREBOOT']       = 'no. of reboots'
    vasp_help_dict['NMIN']          = 'reboot dimension'
    vasp_help_dict['EREF']          = 'reference energy to select bands'
    vasp_help_dict['IMIX']          = 'mixing-type and parameters'
    vasp_help_dict['AMIX']          = ''
    vasp_help_dict['BMIX']          = ''
    vasp_help_dict['AMIX_MAG']      = ''
    vasp_help_dict['BMIX_MAG']      = ''
    vasp_help_dict['AMIN']          = ''
    vasp_help_dict['WC']            = ''
    vasp_help_dict['INIMIX']        = ''
    vasp_help_dict['MIXPRE']        = ''
    vasp_help_dict['MAXMIX']        = ''
    vasp_help_dict['WEIMIN']        = 'energy-eigenvalue tresh-hold'
    vasp_help_dict['EBREAK']        = 'absolut break condition'
    vasp_help_dict['DEPER']         = 'relativ break condition'  
    vasp_help_dict['TIME']          = 'timestep for ELM'
    vasp_help_dict['LWAVE']         = 'write WAVECAR'
    vasp_help_dict['LCHARG']        = 'write CHGCAR'
    vasp_help_dict['LVTOT']         = 'write LOCPOT, total local potential'
    vasp_help_dict['LVHAR']         = 'write LOCPOT, Hartree potential only'
    vasp_help_dict['LELF']          = 'write electronic localiz. function (ELF)'
    vasp_help_dict['LORBIT']        = '0 simple, 1 ext, 2 COOP (PROOUT)'
    vasp_help_dict['LMONO']         = 'monopole corrections only (constant potential shift)'
    vasp_help_dict['LDIPOL']        = 'correct potential (dipole corrections)'
    vasp_help_dict['IDIPOL']        = '1-x, 2-y, 3-z, 4-all directions'
    vasp_help_dict['EPSILON']       = 'bulk dielectric constant'
    vasp_help_dict['GGA']           = 'GGA type'
    vasp_help_dict['LEXCH']         = 'internal setting for exchange type'
    vasp_help_dict['VOSKOWN']       = 'Vosko Wilk Nusair interpolation'
    vasp_help_dict['LHFCALC']       = 'Hartree Fock is set to'
    vasp_help_dict['LHFONE']        = 'Hartree Fock one center treatment'
    vasp_help_dict['AEXX']          = 'exact exchange contribution'
    vasp_help_dict['LEPSILON']      = 'determine dielectric tensor'
    vasp_help_dict['LRPA']          = 'only Hartree local field effects (RPA)'
    vasp_help_dict['LNABLA']        = 'use nabla operator in PAW spheres'
    vasp_help_dict['LVEL']          = 'velocity operator in full k-point grid'
    vasp_help_dict['LINTERFAST']    = 'fast interpolation'
    vasp_help_dict['KINTER']        = 'interpolate to denser k-point grid'
    vasp_help_dict['CSHIFT']        = 'complex shift for real part using Kramers Kronig'
    vasp_help_dict['OMEGAMAX']      = 'maximum frequency'
    vasp_help_dict['DEG_THRESHOLD'] = 'threshold for treating states as degnerate'
    vasp_help_dict['RTIME']         = 'relaxation time in fs'
    vasp_help_dict['ORBITALMAG']    = 'switch on orbital magnetization'
    vasp_help_dict['LCHIMAG']       = 'perturbation theory with respect to B field'
    vasp_help_dict['DQ']            = 'dq finite difference perturbation B field'
    return vasp_help_dict
